/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     CyrFFApi
// @module  CECFFResultsFlusher Implementation | This module contains the include
//          of the CECFFResultsFlusher Implementation
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _CECFFResultsFlusher_h
#define _CECFFResultsFlusher_h

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Standard includes
#include <direct.h>
#include <iostream>
#include <CyrWrapLib/CECTestOutput.h>
#include "CECFFFolder.h"

///////////////////////////////////////////////////////////////////////////////
// Omnithreading
#include <omnithread.h>

///////////////////////////////////////////////////////////////////////////////
// Standard includes
#include <functional>
#include <map>
#include <deque>

///////////////////////////////////////////////////////////////////////////////
// Typedefs
typedef std::deque<string> OutL;
typedef std::map<string,OutL*,std::less<string> > OutTbl;
typedef OutL::iterator OutLIt;
typedef std::map<string,OutLIt, std::less<string> > OutItTbl;

class CECFFResultsFlusher
{
public:
    CECFFResultsFlusher(string testrunPath, OutTbl* pOutput);
    virtual ~CECFFResultsFlusher();
    void Start();
    void Stop();
	BOOL IsRunning();

private:

	BOOL m_bRunning;

    omni_thread* flusher; // @cmember Our internal Flusher Thread
public:
    OutTbl*      m_pOutput;
	    // @cmember Flushes all available Test Output to a file
    void flushList(string key, OutL* list);
	string m_strTestRunPath;
}
;
#endif
