/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: CHK_USERNM_WIN32                */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This routine is used to validate the specified WIN32 username.       */
/*                                       */
/*===========================================================================*/

/*   Define useful Include structures   */

#include  <psl_macros.h>        /* PSL Standard Macros */
#include  <string.h>

#ifdef WIN32

/*
 *  Function Prototypes.
 */
#include psl_common_file (psl_rtndef.h) /* PSL Routines */

/*
 *  Structure Definitions.
 */
#include psl_common_file (shrmsg.h) /* PSL Messages */


/************************************************************************/
/*                                  */
/*  CHK_USERNAME - Validate the specified username          */
/*                                  */
/*      Calling Convention:                     */
/*                                  */
/*    iret = CHK_USERNAME (username_ptr)                */
/*                                  */
/*  where:                              */
/*                                  */
/*    iret = Routine Return Status                  */
/*    username_ptr = Pointer to username string             */
/*                                  */
/*  This routine will validate the specified username               */
/*                                  */
/************************************************************************/

unsigned long   CHK_USERNAME (const char *username_ptr)
{
    /*
     *  Local Data
     */
    char     *wrk_ptr;      /* Work Pointer */

    /*
     *  Just test for a space in the name.
     */
    wrk_ptr = strchr (username_ptr, ' ');

    if (wrk_ptr == NULL)
    {
        return PSL_NORMAL;
    }
    else
    {
        return PSL_BADPARAM;
    }
}
#endif
