/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// LocalRepository.h: interface for the CLocalRepository class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOCALREPOSITORY_H__817F8C9B_42D4_41D4_A22D_B0A66D9DC1FD__INCLUDED_)
#define AFX_LOCALREPOSITORY_H__817F8C9B_42D4_41D4_A22D_B0A66D9DC1FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <OSTAORB/OSTAORB.h>
#include "Factory.h"
#include "CyrWrapLib.h"

#include <string>
using namespace std;

class CLocalRepository  
{
public:
	CLocalRepository(CORBAServer* corba, string strTest, int nPID);
	virtual ~CLocalRepository();
	string GetTestRunString();
	string GetRunFolderName();
	long GetNumResultsFiles();
	CyrStTestRun_ptr m_pTR;
private:

	void MakeActualTestRun();

	CORBAServer* m_pCorba;
	string m_strReposNode;
	string m_strTest;
	string m_strTestRun;
	int m_nPID;
	CECOrbServer* m_pReposServer;
	CECOrbProject* m_pProject;
	CECOrbFolder* m_pRootFolder;
	CECOrbFolder* m_pTestFolder;
	CECOrbFolder* m_pTestStoreFolder;
	CECOrbTestRun* m_pTestRun;
};

#endif // !defined(AFX_LOCALREPOSITORY_H__817F8C9B_42D4_41D4_A22D_B0A66D9DC1FD__INCLUDED_)
