/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// RelayInit.h: interface for the CRelayInit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RELAYINIT_H__83D5121B_66D5_41C8_963A_01CEBFAC11AD__INCLUDED_)
#define AFX_RELAYINIT_H__83D5121B_66D5_41C8_963A_01CEBFAC11AD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "OSTAORB.h"
#include <library.hpp>
#include <list>
#include "xmlrpc.h"
#include "XMLCallProcessor_i.h"
#include "XMLRelayMap_i.h"

///////////////////////////////////////////////////////////////////////////////
// Library function prototypes
typedef int (*PFN_LIB_INIT)( CORBAServer*, CCallManager*, int );
typedef int (*PFN_LIB_UNINIT)();

///////////////////////////////////////////////////////////////////////////////
// Type definitions
// @type    LibList | A list of library modules.
typedef list<CTLibrary*>   LibList;

class CRelayInit  
{
public:
	CRelayInit(CORBAServer* pServer, int nTraceLevel);
	void Run();
	virtual ~CRelayInit();

private:
	CORBAServer* m_pServer;
	int m_nTraceLevel;
    LibList      m_lstLib;

	void LoadHandlers();
	void UnloadHandlers();
	CCallManager* m_pCallManager;
	XMLCallProcessorImpl* m_pCallProcessor;
	XMLRelayMapImpl* m_pRelayMap;
};

#endif // !defined(AFX_RELAYINIT_H__83D5121B_66D5_41C8_963A_01CEBFAC11AD__INCLUDED_)
