/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XML_IS_HTTPTaskSnap.cpp: implementation of the CXML_IS_HTTPTaskSnap class.
//
//////////////////////////////////////////////////////////////////////

#include "XML_IS_HTTPTaskSnap.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXML_IS_HTTPTaskSnap::CXML_IS_HTTPTaskSnap()
{
	m_bSet = false;
}

CXML_IS_HTTPTaskSnap::~CXML_IS_HTTPTaskSnap()
{

}

CXML_IS_HTTPTaskSnap::CXML_IS_HTTPTaskSnap(HTTP_TaskSnap TSnap)
{
	SetValue(TSnap);
}


void CXML_IS_HTTPTaskSnap::SetValue(HTTP_TaskSnap TSnap)
{
	m_HTTP_TaskSnap = TSnap;
	m_bSet = true;
}


HTTP_TaskSnap CXML_IS_HTTPTaskSnap::GetValue()
{
	return m_HTTP_TaskSnap;
}

string CXML_IS_HTTPTaskSnap::GetType()
{
	return "HTTPTaskSnap";
}

string CXML_IS_HTTPTaskSnap::AddMember(string name, CXMLParameter* param)
{
	string strXML = "";
	strXML += "<member>";
	strXML += "<name>"+name+"</name>";
	string strTmp;
	param->ToXML(strTmp);
	strXML += strTmp;
	strXML += "</member>";
	return strXML;
}


bool CXML_IS_HTTPTaskSnap::ToXML(string& strXML)
{
	if (!m_bSet)
		return false;


	strXML += "<value>";
	strXML += "<HTTPTaskSnap>";

	strXML += AddMember("lTaskId",&CXMLLong(m_HTTP_TaskSnap.lTaskId));
	strXML += AddMember("lActiveUsers",&CXMLLong(m_HTTP_TaskSnap.lActiveUsers));
	strXML += AddMember("lIterations",&CXMLLong(m_HTTP_TaskSnap.lIterations));
	strXML += AddMember("lRuntime",&CXMLLong(m_HTTP_TaskSnap.lRuntime));

	strXML += "</HTTPTaskSnap>";
	strXML += "</value>";


	return true;
}

bool CXML_IS_HTTPTaskSnap::FromXML(XmlParse<char>::XMLTree::NodeElement* pNode)
{
    using XmlParse<char>::XMLTree::NodeChild;
    using XmlParse<char>::XMLTree::NodeElement;
    using XmlParse<char>::XMLTree::NodeText;
	using XmlParse<char>::XmlString;

    XmlParse<char>::XMLTree::Children::const_iterator pChild;
	for(pChild = pNode->m_children.begin();
		pChild != pNode->m_children.end();
		++pChild)
	{
		
		XmlParse<char>::XMLTree::NodeElement* pMember = NULL;
		pMember = dynamic_cast<XmlParse<char>::XMLTree::NodeElement*>(*pChild);

		const NodeElement* pName = NULL;
		pName = pMember->GetChildElementByName("name");
		string strName = pName->GetFirstChildText()->m_strValue;

		const NodeElement* pValue = NULL;
		pValue = pMember->GetChildElementByName("value");
		XmlParse<char>::XMLTree::NodeElement* pType = NULL;
		pType = dynamic_cast<XmlParse<char>::XMLTree::NodeElement*>(*pValue->FirstChildElement());

		
		if (strName == "lTaskId")
		{
			CXMLLong* pVal = new CXMLLong();
			pVal->FromXML(pType);
			m_HTTP_TaskSnap.lTaskId=pVal->GetValue();
		}
		else if (strName == "lActiveUsers")
		{
			CXMLLong* pVal = new CXMLLong();
			pVal->FromXML(pType);
			m_HTTP_TaskSnap.lActiveUsers=pVal->GetValue();
		}
		else if (strName == "lIterations")
		{
			CXMLLong* pVal = new CXMLLong();
			pVal->FromXML(pType);
			m_HTTP_TaskSnap.lIterations=pVal->GetValue();
		}
		else if (strName == "lRuntime")
		{
			CXMLLong* pVal = new CXMLLong();
			pVal->FromXML(pType);
			m_HTTP_TaskSnap.lRuntime=pVal->GetValue();
		}
	}

	return true;
}


