/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XML_IS_HTTPTaskSnap.h: interface for the CXML_IS_HTTPTaskSnap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XML_IS_HTTPTASKSNAP_H__F2A14CF8_F6A4_464A_872C_72E412F31E88__INCLUDED_)
#define AFX_XML_IS_HTTPTASKSNAP_H__F2A14CF8_F6A4_464A_872C_72E412F31E88__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "InjectorStatus.h"
#include "HTTPInjectorStatus.h"

class CXML_IS_HTTPTaskSnap : public CXMLParameter  
{
public:
	CXML_IS_HTTPTaskSnap();
	CXML_IS_HTTPTaskSnap(HTTP_TaskSnap TSnap);
	virtual ~CXML_IS_HTTPTaskSnap();

	void SetValue(HTTP_TaskSnap TSnap);
	HTTP_TaskSnap GetValue();

	bool ToXML(string& strXML);
	bool FromXML(XmlParse<char>::XMLTree::NodeElement* pNode);

	string GetType();
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };

private:
	CCallManager* m_pCallManager;
	string AddMember(string name, CXMLParameter* param);

	//variables
	HTTP_TaskSnap m_HTTP_TaskSnap;
	BOOL m_bSet;
};

#endif // !defined(AFX_XML_IS_HTTPTASKSNAP_H__F2A14CF8_F6A4_464A_872C_72E412F31E88__INCLUDED_)
