/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _XMLRELAYARCHMGRIMPL_H_
#define _XMLRELAYARCHMGRIMPL_H_
#include "..\XMLVDK001Lib\XMLRelayArchMgr.h"
#include <OSTAORB.h>
#include <string>
#include "..\RelayMapLib\XMLRelayMap.h"


class XMLRelayArchMgrImpl:public virtual POA_XMLRelayArchMgr,public PortableServer::RefCountServantBase
{
public:
    XMLRelayArchMgrImpl(CORBAServer* corba);
    virtual ~XMLRelayArchMgrImpl();

	virtual char* FileHostProperties(const char* strTargetHost);
	virtual CORBA::Boolean StartOSTADaemon(const char* strTargetHost);
	virtual CORBA::Boolean StopOSTADaemon(const char* strTargetHost);
	virtual CORBA::Boolean RestartOSTADaemon(const char* strTargetHost);
	virtual CORBA::Boolean Stop(const char* strTargetHost);
    virtual CORBA::Boolean IsDmnRunning(const char* strTargetHost);

private:
    CORBAServer* m_corba;
    std::string  m_registered_name;
	XMLRelayMap_ptr m_RelayMap;

};
#endif
