/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include "stdafx.h"
#include "..\RelayDmn\XMLVDK.h"
#include "XMLRelayTimeService_i.h"
#include "TimeServiceHandler.h"
#include <CECInetInfo.h>
#include "..\include\Logger.h"
#include "OstaTraceDef.h"

///////////////////////////////////////////////////////////////////////////////
// Global variables
CLogger* g_Logger = NULL;
XMLRelayTimeServiceImpl* TSRelay = NULL;
CTimeServiceHandler* TSHandler = NULL;
///////////////////////////////////////////////////////////////////////////////
// @func   This function initialises Name service cleaner
// @rdesc A standard Cyrano error code.
XMLVDK_EXP XMLVDKInit( CORBAServer* pServer, CCallManager* pCallManager, int nTraceLevel )
{
	g_Logger = new CLogger("XMLVDK004_Log.txt");
	g_Logger->SetLevel(nTraceLevel);
	g_Logger->WriteLogMsg(TRCLEV_NONE, "XMLVDK004 Loaded.");

	char buf[4];
	sprintf(buf,"%d",nTraceLevel);
	g_Logger->WriteLogMsg(TRCLEV_NONE, "Trace Level = "+string(buf));

	TSRelay = new XMLRelayTimeServiceImpl(pServer);
	TSHandler = new CTimeServiceHandler(pServer);

	pCallManager->AddHandler("TIMESERVICE", TSHandler);
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
// @func  This function stops the  Name service cleaner
// @rdesc A standard Cyrano error code.
XMLVDK_EXP XMLVDKShutdown()
{
	delete g_Logger;
	delete TSRelay;
	delete TSHandler;
	return 0;
}

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        CyrtoolsInitialize();
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
        CyrtoolsUninitialize();
    }
    return TRUE;
}
