/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// FileControl.h: interface for the CFileControl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILECONTROL_H__CF47E544_D821_40B7_8AF7_77C136845421__INCLUDED_)
#define AFX_FILECONTROL_H__CF47E544_D821_40B7_8AF7_77C136845421__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "OSTAORB.h"
//#include "FileTransferNode.h"

#include <string>
using namespace std;


class CFileControl : public CCallHandler  
{
public:
	CFileControl(CORBAServer* pServer, CServerSettings& settings);
	virtual ~CFileControl();

	CXMLResponse* ProcessMethodCall(CXMLRequest* request);

	CXMLResponse* CheckOutReposTraceSettings(string strReposHost);
	CXMLResponse* CheckOutReposProfile(string strReposHost, string strProfile);
	CXMLResponse* CheckOutReposScript(string strReposHost, string strScript);
	CXMLResponse* CheckOutReposData(string strReposHost, string strData);

	CXMLResponse* CheckInReposResults(string strReposHost, string strFileURL, string strTest, string strTestRun);
	CXMLResponse* StoreResultsFile(string strReposHost, string strFileName, string strTest, string strTestRun, string strInjector);

private:
	CORBAServer* m_pCorba;
	CServerSettings m_settings;
	bool ParseFTPURL(string strURL, string& strServer, int& nPort, string& strUser,
				string& strPass, string& strRemotePath);

};

#endif // !defined(AFX_FILECONTROL_H__CF47E544_D821_40B7_8AF7_77C136845421__INCLUDED_)
