/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// InjectorControlHandler.h: interface for the CInjectorControlHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INJECTORCONTROLHANDLER_H__EA9FB71B_5FDD_4F48_9F71_833C0C68A907__INCLUDED_)
#define AFX_INJECTORCONTROLHANDLER_H__EA9FB71B_5FDD_4F48_9F71_833C0C68A907__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "OSTAORB.h"
#include <string>
using namespace std;
#include "InjectorControl.h"

class CInjectorControlHandler : public CCallHandler  
{
public:
	CInjectorControlHandler(CORBAServer* pServer);
	virtual ~CInjectorControlHandler();

	CXMLResponse* ProcessMethodCall(CXMLRequest* request);
	CXMLResponse* Activate(string strTargetMachine, string strManagerRegString,
						   string strReposHost, string strTestRunString, string strTestName);
	CXMLResponse* IsActivated(string strTargetMachine, string strManagerRegString);
	CXMLResponse* StartTaskGroup(string strTargetMachine, TaskGroupExecInfo tgExec);
	CXMLResponse* StopTaskGroup(string strTargetMachine, long lTaskGroupId);
	CXMLResponse* StopTest(string strTargetMachine, bool bForce, long lTimeout);
	CXMLResponse* TransferResults(string strTargetMachine, string strTestName, string strReposHost,
									string strRunFolder);

private:
	CORBAServer* m_pCorba;

};

#endif // !defined(AFX_INJECTORCONTROLHANDLER_H__EA9FB71B_5FDD_4F48_9F71_833C0C68A907__INCLUDED_)
