/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// InjectorStatusHandler.h: interface for the CInjectorStatusHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INJECTORSTATUSHANDLER_H__77C4C3C7_F481_466E_A883_3EA8FCD6562B__INCLUDED_)
#define AFX_INJECTORSTATUSHANDLER_H__77C4C3C7_F481_466E_A883_3EA8FCD6562B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xmlrpc.h"
#include "OSTAORB.h"
#include <string>
using namespace std;
#include "InjectorStatus.h"
#include "HTTPInjectorStatus.h"

class CInjectorStatusHandler : public CCallHandler  
{
public:
	CInjectorStatusHandler(CORBAServer* pServer);
	virtual ~CInjectorStatusHandler();

	CXMLResponse* ProcessMethodCall(CXMLRequest* request);

	CXMLResponse* GetStatsSnapshot(string strTargetMachine);
	CXMLResponse* GetInjectorVUs(string strTargetMachine, long lPreviousTestVUCount);
	CXMLResponse* GetTaskSnapshot(string strTargetMachine, const TaskIdList& taskIDs);
	CXMLResponse* HTTP_GetBothStatsSnapshots(string strTargetMachine);
	CXMLResponse* StartMonitoring(string strTargetMachine, string strFilename,long lInterval);


private:
	CORBAServer* m_pCorba;

};

#endif // !defined(AFX_INJECTORSTATUSHANDLER_H__77C4C3C7_F481_466E_A883_3EA8FCD6562B__INCLUDED_)
