/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _XMLRelayInjectorControlImpl_H_
#define _XMLRelayInjectorControlImpl_H_
#include "..\XMLVDK010Lib\XMLRelayInjectorControl.h"
#include "..\RelayMapLib\XMLRelayMap.h"
#include <OSTAORB.h>
#include <string>
class XMLRelayInjectorControlImpl:public virtual POA_XMLRelayInjectorControl,public PortableServer::RefCountServantBase
{
public:
    XMLRelayInjectorControlImpl(CORBAServer* corba);
    virtual ~XMLRelayInjectorControlImpl();
    virtual CORBA::Boolean Activate(const char* strTargetMachine,
								    const char* strManagerRegString, const char* strReposHost,
								    const char* strTestRunString, const char* strTestName);


    virtual CORBA::Boolean IsActivated(const char* strTargetMachine, 
									   const char* strManagerRegString);

	virtual CORBA::Boolean StartTaskGroup(const char* strTargetMachine, TaskGroupExecInfo& tgExec);
	virtual CORBA::Boolean StopTaskGroup(const char* strTargetMachine, CORBA::Long lTaskGroupId);
	virtual CORBA::Boolean StopTest(const char* strTargetMachine, CORBA::Boolean bForce, CORBA::Long lTimeout);
	CORBA::Long TransferResults(const char* strTargetMachine, const char* strTestName, const char* strReposHost, const char* strRunFolder);

private:
    CORBAServer* m_corba;
    std::string  m_registered_name;
	XMLRelayMap_ptr m_RelayMap;
};
#endif
