/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLRelayInjectorStatus_i.h: interface for the XMLRelayInjectorStatusImpl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLRELAYINJECTORSTATUS_I_H__F420F28C_9CDE_409B_BADB_896C668DDDFD__INCLUDED_)
#define AFX_XMLRELAYINJECTORSTATUS_I_H__F420F28C_9CDE_409B_BADB_896C668DDDFD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\XMLVDK010Lib\XMLRelayInjectorStatus.h"
#include "..\RelayMapLib\XMLRelayMap.h"
#include <OSTAORB.h>
#include <string>

class XMLRelayInjectorStatusImpl:public virtual POA_XMLRelayInjectorStatus,public PortableServer::RefCountServantBase  
{
public:
	XMLRelayInjectorStatusImpl(CORBAServer* corba);
	virtual ~XMLRelayInjectorStatusImpl();

	virtual CORBA::Boolean HTTP_GetBothStatsSnapshots(const char* strTargetMachine,HTTP_TestExecuterSnapshot_out HTTP_InjectorSnapshot, TESnapList_out InjectorSnapList);
	virtual CORBA::Boolean GetStatsSnapshot(const char* strTargetMachine, TESnapList& InjectorSnapList);
	virtual CORBA::Long GetInjectorVUs(const char* strTargetMachine, CORBA::Long lPreviousTestVUCount);
	virtual CORBA::Boolean GetTaskSnapshot(const char* strTargetMachine, const TaskIdList& taskIDs, TaskSnap2List& taskSnapshots);
	virtual CORBA::Boolean StartMonitoring(const char* strTargetMachine,const char* strFilename,long lInterval);
private:
	CORBAServer* m_corba;
    std::string  m_registered_name;
	XMLRelayMap_ptr m_RelayMap;

};

#endif // !defined(AFX_XMLRELAYINJECTORSTATUS_I_H__F420F28C_9CDE_409B_BADB_896C668DDDFD__INCLUDED_)
