/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ServerSettings.h: interface for the CServerSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVERSETTINGS_H__F5F17C0A_26AA_4002_8B06_19E29C48F003__INCLUDED_)
#define AFX_SERVERSETTINGS_H__F5F17C0A_26AA_4002_8B06_19E29C48F003__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <iostream>
using namespace std;

class CServerSettings  
{
public:
	CServerSettings();
	virtual ~CServerSettings();

	bool ReadSettings(string strFile);
	bool SaveSettings(string strFile);

	// Web Server Settings
	int m_nWebPort;
	string m_strWebRoot;
	string m_strExtensionPath;
	string m_strCachePath;
	bool m_bUseSSL;

	// FTP Server Settings
	bool m_bUseFTP;
	int m_nFtpPort;
	string m_strFtpRoot;
	string m_strFtpUser;
	string m_strFtpPass;

	CServerSettings& operator = (CServerSettings& src);
};

#endif // !defined(AFX_SERVERSETTINGS_H__F5F17C0A_26AA_4002_8B06_19E29C48F003__INCLUDED_)
