/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLArray.h: interface for the CXMLArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLARRAY_H__8B28B494_3C1A_4480_BB79_F66D932213C0__INCLUDED_)
#define AFX_XMLARRAY_H__8B28B494_3C1A_4480_BB79_F66D932213C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLParameter.h"

class CXMLArray : public CXMLParameter  
{
public:
	CXMLArray();
	virtual ~CXMLArray();
	bool ToXML(string& strXML);
	bool FromXML(XmlParse<char>::XMLTree::NodeElement* pNode);

	void AddElement(CXMLParameter* element);
	int GetSize();
	CXMLParameter* GetAt(int nPos);

	string GetType() { return "array"; };
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };

private:

	CCallManager* m_pCallManager;
	CArray <CXMLParameter*,CXMLParameter*> m_elements;
};

#endif // !defined(AFX_XMLARRAY_H__8B28B494_3C1A_4480_BB79_F66D932213C0__INCLUDED_)
