/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLBool.cpp: implementation of the CXMLBool class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XMLBool.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLBool::CXMLBool()
{
	m_bSet = false;
}

CXMLBool::CXMLBool(bool bValue)
{
	SetValue(bValue);
}

CXMLBool::~CXMLBool()
{

}

bool CXMLBool::ToXML(string& strXML)
{
	if (!m_bSet)
		return false;

	char strVal[2];
	sprintf(strVal,"%d",(int) m_bVal);
	
	strXML += "<value><boolean>"+string(strVal)+"</boolean></value>";
	return true;
}

bool CXMLBool::FromXML(XmlParse<char>::XMLTree::NodeElement* pNode)
{
	// pNode is the <bool> node of the xml. So need to get the XMLText child
	// node to get the int value

	XmlParse<char>::XMLTree::NodeText* pText = NULL;
	pText = dynamic_cast<XmlParse<char>::XMLTree::NodeText*>(*pNode->m_children.begin());

	string strValue = pText->m_strValue;

	SetValue((bool)atoi(strValue.c_str()));

	return true;
}

void CXMLBool::SetValue(bool bValue)
{
	m_bVal = bValue;
	m_bSet = true;
}

bool CXMLBool::GetValue()
{
	return m_bVal;
}
