/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLDate.cpp: implementation of the CXMLDate class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XMLDate.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLDate::CXMLDate()
{
	m_bSet = false;
}

CXMLDate::CXMLDate(CTime tmValue)
{
	SetValue(tmValue);
}

CXMLDate::~CXMLDate()
{

}

bool CXMLDate::ToXML(string& strXML)
{
	if (!m_bSet)
		return false;

	string strVal = m_tmVal.Format("%Y-%m-%dT%H:%M:%S");
	
	strXML += "<value><dateTime.iso8601>"+strVal+"</dateTime.iso8601></value>";
	return true;
}

bool CXMLDate::FromXML(XmlParse<char>::XMLTree::NodeElement* pNode)
{
	// pNode is the <int> node of the xml. So need to get the XMLText child
	// node to get the int value

	XmlParse<char>::XMLTree::NodeText* pText = NULL;
	pText = dynamic_cast<XmlParse<char>::XMLTree::NodeText*>(*pNode->m_children.begin());

	

	string strValue = pText->m_strValue;
	int nYear = atoi(strValue.substr(0,4).c_str());
	strValue.erase(0,5);
	int nMonth = atoi(strValue.substr(0,2).c_str());
	strValue.erase(0,3);
	int nDay = atoi(strValue.substr(0,2).c_str());
	strValue.erase(0,3);
	int nHours = atoi(strValue.substr(0,2).c_str());
	strValue.erase(0,3);
	int nMins = atoi(strValue.substr(0,2).c_str());
	strValue.erase(0,3);
	int nSecs = atoi(strValue.substr(0,2).c_str());


	CTime tm(nYear, nMonth, nDay, nHours, nMins, nSecs);
	SetValue(tm);

	return true;
}

void CXMLDate::SetValue(CTime tmValue)
{
	m_tmVal = tmValue;
	m_bSet = true;
}

CTime CXMLDate::GetValue()
{
	return m_tmVal;
}
