/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLDouble.cpp: implementation of the CXMLDouble class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XMLDouble.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLDouble::CXMLDouble()
{
	m_bSet = false;
}

CXMLDouble::CXMLDouble(double dValue)
{
	SetValue(dValue);
}

CXMLDouble::~CXMLDouble()
{

}

bool CXMLDouble::ToXML(string& strXML)
{
	if (!m_bSet)
		return false;

	char strVal[16];
	sprintf(strVal,"%d",m_dVal);

	strXML += "<value><double>"+string(strVal)+"</double></value>";
	return true;
}

bool CXMLDouble::FromXML(XmlParse<char>::XMLTree::NodeElement* pNode)
{
	// pNode is the <double> node of the xml. So need to get the XMLText child
	// node to get the double value

	XmlParse<char>::XMLTree::NodeText* pText = NULL;
	pText = dynamic_cast<XmlParse<char>::XMLTree::NodeText*>(*pNode->m_children.begin());

	string strValue = pText->m_strValue;

	SetValue(atof(strValue.c_str()));

	return true;
}

void CXMLDouble::SetValue(double dValue)
{
	m_dVal = dValue;
	m_bSet = true;
}

double CXMLDouble::GetValue()
{
	return m_dVal;
}
