/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLInt.h: interface for the CXMLInt class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLINT_H__80DE49F7_2C1B_44B8_8F85_427D9B388D40__INCLUDED_)
#define AFX_XMLINT_H__80DE49F7_2C1B_44B8_8F85_427D9B388D40__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLParameter.h"

class CXMLInt : public CXMLParameter  
{
public:
	CXMLInt();
	CXMLInt(int iValue);
	virtual ~CXMLInt();
	bool ToXML(string& strXML);
	bool FromXML(XmlParse<char>::XMLTree::NodeElement* pNode);

	void SetValue(int iValue);
	int GetValue();

	string GetType() { return "int"; };
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };
private:
	int m_iVal;
	bool m_bSet;
	CCallManager* m_pCallManager;
};

#endif // !defined(AFX_XMLINT_H__80DE49F7_2C1B_44B8_8F85_427D9B388D40__INCLUDED_)
