/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XMLLong.h: interface for the CXMLLong class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLLONG_H__68A802DA_ECC7_4924_8CE0_76B53E6321FD__INCLUDED_)
#define AFX_XMLLONG_H__68A802DA_ECC7_4924_8CE0_76B53E6321FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLParameter.h"

class CXMLLong : public CXMLParameter  
{
public:
	CXMLLong();
	CXMLLong(long lValue);
	virtual ~CXMLLong();

	bool ToXML(string& strXML);
	bool FromXML(XmlParse<char>::XMLTree::NodeElement* pNode);

	void SetValue(long lValue);
	long GetValue();

	string GetType() { return "i4"; };
	void SetCallManager(CCallManager* pCallManager) { m_pCallManager = pCallManager; };
private:
	long m_lVal;
	bool m_bSet;
	CCallManager* m_pCallManager;
};

#endif // !defined(AFX_XMLLONG_H__68A802DA_ECC7_4924_8CE0_76B53E6321FD__INCLUDED_)
