/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     OstaTraceDef
// @module  OpenSTA Trace Codes | This module is intended to hold the complete
//          list of all the Trace category strings and Trace level numbers that
//          may be used when writing to OpenSTA Trace files.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _OstaTraceDef_h
#define _OstaTraceDef_h

// Trace categories.
#define TRCCAT_STARTUP      "Startup"       // Test startup
#define TRCCAT_SHUTDOWN     "Shutdown"      // Test shutdown
#define TRCCAT_REPOSITORY   "Repository"    // Repository access
#define TRCCAT_RUNNING      "Running"       // Test running

// Trace Levels
#define TRCLEV_NONE          0              // Fatal Errors only
#define TRCLEV_LOW          10              // Important Trace error
#define TRCLEV_MEDIUM       20              // Normal Trace Level
#define TRCLEV_HIGH         50              // High Trace level

#endif
