/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECCheckBoxCell.cpp: implementation of the CECCheckBoxCell class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CECCheckBoxCell.h"
#include "InPlaceEdit.h"
#include "GridCtrl.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CECCheckBoxCell,CGridCell)
CECCheckBoxCell::CECCheckBoxCell():
	m_bChecked(false),
	m_nRow(0),
	m_nCol(0)
{
}

CECCheckBoxCell::~CECCheckBoxCell()
{

}

BOOL CECCheckBoxCell::Edit(int nRow, int nCol, CRect rect, CPoint point, UINT nID, UINT nChar)
{
/*    ASSERT( m_pBtnDataBase != NULL);

    if( ProcessCtlClick(WM_LBUTTONUP,       // Command that invoked.  e.g. WM_LBUTTONDOWN
                        point) ) // point to check for hit
    {
        SendMessageToParent( m_iRow, m_iCol, NM_CLICK); // tell parent about it
        return FALSE;   // clicked a control rather than edited a value
    }


    const int iCtlNbr = GetDrawCtlNbr();
    if( iCtlNbr > 0 )
    {
        // if there's at least one left-aligned control and user pressed
        //  space bar, activate that control
        if( GetDrawCtlAlign( 0) == CTL_ALIGN_LEFT
                || iCtlNbr == 1)
        {
            if( nChar == ' ' )
            {
                // user hit space bar -- just like clicking a button
                ClickedCellCtl( WM_LBUTTONDOWN,   // Command that invoked.  e.g. WM_LBUTTONDOWN
                                0);    // zero-based index of image to draw
                Sleep( 200);
                ClickedCellCtl( WM_LBUTTONUP,   // Command that invoked.  e.g. WM_LBUTTONDOWN
                                0);    // zero-based index of image to draw

                SendMessageToParent( m_iRow, m_iCol, NM_CLICK); // tell parent about it

                return FALSE;   // clicked a control rather than edited a value
            }

        }
    }
*/
    return TRUE;
}

BOOL CECCheckBoxCell::Draw(CDC* pDC, int nRow, int nCol, CRect rect,
                            BOOL bEraseBkgnd /*=TRUE*/)
{
	BOOL bResult = CGridCellBase::Draw(pDC,nRow,nCol,rect,bEraseBkgnd);
	m_nRow = nRow;
	m_nCol = nCol;

	const CSize szBox(12,12);
	
	CPoint ptTopLeft(rect.CenterPoint());
	ptTopLeft -= CSize(szBox.cx/2,szBox.cy/2);
	
	CRect rcBox(ptTopLeft,szBox);
	m_rcBox = rcBox;

	CPen pen(PS_SOLID,1,RGB(0,0,0));
	CPen *pOldPen = pDC->SelectObject(&pen);
	pDC->Rectangle(rcBox);
	 
	if(m_bChecked)
	{
		CPen penX(PS_SOLID,2,RGB(80,80,80));
		CPen *pOldPen = pDC->SelectObject(&penX);
	
		rcBox.DeflateRect(2,2,3,3);
		pDC->MoveTo(rcBox.left,rcBox.top);
		pDC->LineTo(rcBox.right,rcBox.bottom);
 
		pDC->MoveTo(rcBox.right,rcBox.top);
		pDC->LineTo(rcBox.left,rcBox.bottom);
		
		pDC->SelectObject(pOldPen);
	}

	pDC->SelectObject(pOldPen);
	
	return bResult;
}

void CECCheckBoxCell::OnClickDown( CPoint PointCellRelative)
{
	DWORD dwState = GetState();
	if(dwState & GVIS_READONLY)
		return;

	CRect rcCell;
	GetGrid()->GetCellRect(m_nRow,m_nCol,rcCell);

	if(m_rcBox.PtInRect(PointCellRelative+rcCell.TopLeft()))
	{
		m_bChecked = !m_bChecked;
		SendMessageToParent(m_nRow,m_nCol,NM_CELLCHECKED);
	}
}

