/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECCheckBoxCell.h: interface for the CECCheckBoxCell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECCHECKBOXCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_)
#define AFX_CECCHECKBOXCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define NM_CELLCHECKED (NM_LAST+1)
#include "GridCell.h"

class CECCheckBoxCell : public CGridCell
{
public:
	CECCheckBoxCell();
	DECLARE_DYNCREATE(CECCheckBoxCell);

	virtual ~CECCheckBoxCell();
	BOOL Edit(int nRow, int nCol, CRect rect, CPoint point, UINT nID, UINT nChar);

	BOOL Draw(CDC* pDC, int nRow, int nCol, CRect rect,BOOL bEraseBkgnd /*=TRUE*/);

	void SetCheck(BOOL bSet=true){m_bChecked = bSet;}
	BOOL GetCheck(){return m_bChecked;}

protected:
	virtual void OnClickDown( CPoint PointCellRelative);
private:
	CRect m_rcBox;
	BOOL m_bChecked;
	int m_nRow,m_nCol;
};

#endif // !defined(AFX_CECCHECKBOXCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_)
