/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// SCLCompiler.h: interface for the CSCLCompiler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCLCOMPILER_H__CC04F083_E549_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_SCLCOMPILER_H__CC04F083_E549_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSCLCompiler  
{
public:
	CSCLCompiler();
	virtual ~CSCLCompiler();

	BOOL CompileScript(const CString& strScript,BOOL bCompileDependencies=false);
	void SetOutputFolder(const CString& strFolder);
	CString GetErrorMessage(){return m_strErrorMsg;}

private:
	BOOL IsUptodate(const CString& strScript,const CString& strTof);
	BOOL GenerateOutputPath(const CString& strSrcPath,CString& strOutputPath,CString& strDependPath);
	CString GetCompilerPath();
	BOOL GenerateCommandLine(const CString& strScript,const CString& strOutput,CString& strCmdLine);
	
private:
	CString m_strErrorMsg;
	CString m_strOutputFolder;
};

#endif // !defined(AFX_SCLCOMPILER_H__CC04F083_E549_11D4_94C9_00C04F89E392__INCLUDED_)
