/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// EditRelayDef.cpp : implementation file
//

#include "stdafx.h"
#include "relaycfg.h"
#include "EditRelayDef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditRelayDef dialog


CEditRelayDef::CEditRelayDef(CWnd* pParent /*=NULL*/)
	: CDialog(CEditRelayDef::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditRelayDef)
	m_strAlias = _T("");
	m_strExtPath = _T("");
	m_strIPAddress = _T("");
	m_strPass = _T("");
	m_bUseSSL = FALSE;
	m_strUser = _T("");
	m_strPort = _T("");
	//}}AFX_DATA_INIT
}


void CEditRelayDef::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditRelayDef)
	DDX_Text(pDX, IDC_ALIAS, m_strAlias);
	DDX_Text(pDX, IDC_EXT_PATH, m_strExtPath);
	DDX_Text(pDX, IDC_IP_ADDRESS, m_strIPAddress);
	DDX_Text(pDX, IDC_PASSWORD, m_strPass);
	DDX_Check(pDX, IDC_USE_SSL, m_bUseSSL);
	DDX_Text(pDX, IDC_USERNAME, m_strUser);
	DDX_Text(pDX, IDC_PORT, m_strPort);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditRelayDef, CDialog)
	//{{AFX_MSG_MAP(CEditRelayDef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditRelayDef message handlers

void CEditRelayDef::OnOK() 
{

	UpdateData(TRUE);

	CDialog::OnOK();
}
