// TestDebugCommsProxy.h: interface for the CTestDebugCommsProxy class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTDEBUGCOMMSPROXY_H__E8594EE5_6A65_4C5B_985B_EF5749BC70AA__INCLUDED_)
#define AFX_TESTDEBUGCOMMSPROXY_H__E8594EE5_6A65_4C5B_985B_EF5749BC70AA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HttpSingleStepFile.h"

class CTestDebug;
class CTestDebugCommsProxy  
{
public:
	CTestDebugCommsProxy(CTestDebug *);
	virtual ~CTestDebugCommsProxy();

	BOOL NotifyNextRequest(CNextRequestData*);
	BOOL NotifyRequestComplete(CRequestCompleteData*);
	BOOL NotifyReadyToStep();
	BOOL NotifyRunning();
	BOOL NotifyStepped(int,int);

	BOOL NotifyTestComplete();
private:
	CTestDebug *m_pTestDebug;

	CWinThread *m_pCommandThread;

	HANDLE m_hPipe;
	HANDLE m_hTerminateEvent;

	BOOL CreateCommsPipe();
	BOOL WaitForPipeConnection();
	BOOL ReadFromPipe(LPBYTE pBuffer,DWORD dwBufSize);
	BOOL WriteToPipe(LPBYTE pBuffer, DWORD dwBufSize);

	static UINT CommandThread(LPVOID pParam);

	CCriticalSection m_CritSect;
};

#endif // !defined(AFX_TESTDEBUGCOMMSPROXY_H__E8594EE5_6A65_4C5B_985B_EF5749BC70AA__INCLUDED_)
