// TaskGroupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TaskGroupDlg.h"
#include "TestFile.h"
#include "TestCtrl.h"
#include "BaseUIHelpID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTaskGroupDlg dialog


CTaskGroupDlg::CTaskGroupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskGroupDlg::IDD, pParent),
	m_pTestFile(NULL),
	m_nTaskGroup(-1),
	m_hwndNotify(NULL)
{
	//{{AFX_DATA_INIT(CTaskGroupDlg)
	m_bTGEnabled = FALSE;
	m_strCaption = _T("");
	m_nIterations = 0;
	m_nStartAtDays = 0;
	m_nDelayDays = 0;
	m_WarningString = _T("");
	//}}AFX_DATA_INIT
}


void CTaskGroupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTaskGroupDlg)
	DDX_Control(pDX, IDC_START_DELAY, m_ctlStartDelay);
	DDX_Control(pDX, IDC_TG_START, m_ctlTGStart);
	DDX_Control(pDX, IDC_STARTAT_DAYS_SPIN, m_ctlStartAtDaySpin);
	DDX_Control(pDX, IDC_STARTAT_DAYS, m_ctlStartAtDays);
	DDX_Control(pDX, IDC_STARTAT_TIME, m_ctlStartAtTime);
	DDX_Control(pDX, IDC_ITER_SPIN, m_ctlIterSpin);
	DDX_Control(pDX, IDC_ITERATIONS, m_ctlIterations);
	DDX_Control(pDX, IDC_TIMELIMIT, m_ctlTimeLimit);
	DDX_Control(pDX, IDC_TG_TERMINATION, m_ctlTGTermination);
	DDX_Text(pDX, IDC_CAPTION, m_strCaption);
	DDX_Text(pDX, IDC_ITERATIONS, m_nIterations);
	DDX_Text(pDX, IDC_STARTAT_DAYS, m_nStartAtDays);
	DDX_Text(pDX, IDC_NO_TG_EDIT, m_WarningString);

	DDX_Control(pDX, IDC_DELAY_DAYS_SPIN, m_ctlDelayDaySpin);
	DDX_Control(pDX, IDC_DELAY_DAYS, m_ctlDelayDays);
	DDX_Text(pDX, IDC_DELAY_DAYS, m_nDelayDays);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTaskGroupDlg, CDialog)
	//{{AFX_MSG_MAP(CTaskGroupDlg)
	ON_CBN_SELCHANGE(IDC_TG_TERMINATION, OnSelchangeTgTermination)
	ON_EN_CHANGE(IDC_ITERATIONS, OnChangeIterations)
	ON_EN_CHANGE(IDC_STARTAT_DAYS, OnChangeStartatDays)
	ON_EN_CHANGE(IDC_STARTAT_TIME, OnChangeStartatTime)
	ON_EN_CHANGE(IDC_TIMELIMIT, OnChangeTimelimit)
	ON_CBN_SELCHANGE(IDC_TG_START, OnSelchangeTgStart)
	ON_EN_CHANGE(IDC_DELAY_DAYS, OnChangeDelayDays)
	ON_EN_CHANGE(IDC_START_DELAY, OnChangeStartDelay)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTaskGroupDlg message handlers
void CTaskGroupDlg::SetTestFile(CTestFile *pTestFile,int nGroup,HWND hwndNotify)
{
	m_pTestFile = pTestFile;
	m_nTaskGroup = nGroup;
	m_hwndNotify = hwndNotify;
	
	//load taskGroupData nGroup
	DWORD  dwBufSize=0;
	LPBYTE pLoadData = NULL;
	m_pTestFile->GetTaskGroupData(nGroup,&pLoadData,dwBufSize);

	m_TGData.LoadFromBuffer(pLoadData);

	m_bTGEnabled = m_TGData.GetTaskGroupEnabled();

	m_ctlTGTermination.ResetContent();
	//If its a script then can be on completion termination
	m_ctlTGTermination.AddString("Manually");
	m_ctlTGTermination.AddString("After fixed time");

	CTestFile::TaskType nType = m_pTestFile->GetTaskType(nGroup,0);
	if(nType==CTestFile::enScript)
		m_ctlTGTermination.AddString("On Completion");

	if(m_TGData.GetbIsDuration()==FALSE)	//No duration so this is on completion
	{
		m_ctlTGTermination.SetCurSel(2);	//On Completion
	}
	else
	{
		if(m_TGData.GetTaskDuration()>=0)
		{
			m_ctlTGTermination.SetCurSel(1);
		}
		else
		{
			//ifBIsDuration is TRUE and GetTaskDuration is <0
			// termination is never
			m_ctlTGTermination.SetCurSel(0);
		}
	
	}
	OnSelchangeTgTermination();

	m_ctlTGStart.ResetContent();
	m_ctlTGStart.AddString("Scheduled");
	m_ctlTGStart.AddString("Immediately");
	m_ctlTGStart.AddString("Delayed");

	if(m_TGData.GetIsScheduled()==TRUE)
	{
		//scheduled
		m_ctlTGStart.SetCurSel(0);
	}
	else if(m_TGData.GetIsDelayed()==FALSE)
	{
		//immediately	- delay is zero
		m_ctlTGStart.SetCurSel(1);
	}
	else
	{
		//delayed - delay is >0
		m_ctlTGStart.SetCurSel(2);
	}

	OnSelchangeTgStart();

    const int nNumAccel = 3;
    UDACCEL arAccel[nNumAccel];
    arAccel[0].nInc = 1;
    arAccel[0].nSec = 2;
    arAccel[1].nInc = 10;
    arAccel[1].nSec = 3;
    arAccel[2].nInc = 100;
    arAccel[2].nSec = 4;
	
	m_ctlIterSpin.SetAccel(nNumAccel,arAccel);
	m_ctlIterSpin.SetRange(1,UD_MAXVAL);

	m_ctlStartAtDaySpin.SetAccel(nNumAccel,arAccel);
	m_ctlStartAtDaySpin.SetRange(0,999);	//the CString that this is stored in is limited to "+999 00:00:00" 13 characters

	m_ctlDelayDaySpin.SetAccel(nNumAccel,arAccel);
	m_ctlDelayDaySpin.SetRange(0,999);
	UpdateData(FALSE);
}

void CTaskGroupDlg::OnSelchangeTgStart() 
{
	switch(m_ctlTGStart.GetCurSel())
	{
	case 0:
		{
		//scheduled
		m_ctlStartAtTime.ShowWindow(SW_SHOW);
		m_ctlStartAtDays.ShowWindow(SW_SHOW);
		GetDlgItem(IDC_SCHEDULE_BOX)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_DAYS_LABEL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_TIME_LABEL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STARTAT_DAYS_SPIN)->ShowWindow(SW_SHOW);
		m_ctlStartAtTime.EnableWindow(TRUE);
		m_ctlStartAtDays.EnableWindow(TRUE);
		m_ctlStartDelay.ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_BOX)->ShowWindow(FALSE);
		GetDlgItem(IDC_START_DELAY)->ShowWindow(FALSE);
		m_ctlDelayDays.ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_DAYS_SPIN)->ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_DAYS)->ShowWindow(FALSE);



		//re parse the string
		CString strTime = m_TGData.GetScheduledTime();
		strTime.Remove('+');
		char* szToken = strtok( strTime.GetBuffer(0), " ");
		int nDays = atoi(szToken);
		szToken = strtok(NULL, ":");
		int nHours = atoi(szToken);
		szToken = strtok(NULL, ":");
		int	nMins = atoi(szToken);
		szToken = strtok( NULL, "\0");
		int nSecs = atoi(szToken);
		m_ctlStartAtTime.SetHours(nHours);
		m_ctlStartAtTime.SetMinutes(nMins);
		m_ctlStartAtTime.SetSeconds(nSecs);
		m_nStartAtDays = nDays;
	
		m_TGData.SetIsScheduled(TRUE);
		m_TGData.SetIsDelayed(FALSE);
		break;
		}
	case 1:
		{
		//immediately
		m_ctlStartAtTime.ShowWindow(SW_HIDE);
		m_ctlStartAtDays.ShowWindow(SW_HIDE);
		GetDlgItem(IDC_SCHEDULE_BOX)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_DAYS_LABEL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_TIME_LABEL)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STARTAT_DAYS_SPIN)->ShowWindow(SW_HIDE);
		m_ctlStartDelay.ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_BOX)->ShowWindow(FALSE);
		GetDlgItem(IDC_START_DELAY)->ShowWindow(FALSE);
		m_ctlDelayDays.ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_DAYS_SPIN)->ShowWindow(FALSE);
		GetDlgItem(IDC_DELAY_DAYS)->ShowWindow(FALSE);
			
		m_TGData.SetIsScheduled(FALSE);
		m_TGData.SetIsDelayed(FALSE);

		break;
		}
	case 2:
		{
		//delayed
		m_ctlStartAtTime.ShowWindow(SW_HIDE);
		m_ctlStartAtDays.ShowWindow(SW_HIDE);
		GetDlgItem(IDC_SCHEDULE_BOX)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_DAYS_LABEL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_TIME_LABEL)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STARTAT_DAYS_SPIN)->ShowWindow(SW_HIDE);
		m_ctlStartDelay.EnableWindow(TRUE);
		GetDlgItem(IDC_START_DELAY)->ShowWindow(TRUE);
		GetDlgItem(IDC_DELAY_BOX)->ShowWindow(TRUE);
		m_ctlDelayDays.ShowWindow(TRUE);
		GetDlgItem(IDC_DELAY_DAYS_SPIN)->ShowWindow(TRUE);
		GetDlgItem(IDC_DELAY_DAYS)->ShowWindow(TRUE);

		m_TGData.SetIsScheduled(FALSE);
		m_TGData.SetIsDelayed(TRUE);

		//reload the values
		long totalseconds=m_TGData.GetStartDelay();
		div_t temp;
		int remainder;

		//CString s1;
		//s1.Format("total delay in seconds is %d",totalseconds);
		//AfxMessageBox(s1);

		temp=div(totalseconds,3600*24);
		m_nDelayDays=temp.quot;
		remainder=temp.rem;
		temp=div(remainder,3600);
		m_ctlStartDelay.SetHours(temp.quot);
		remainder=temp.rem;
		temp=div(remainder,60);
		m_ctlStartDelay.SetMinutes(temp.quot);
		m_ctlStartDelay.SetSeconds(temp.rem);

		break;
		}
	default:
		{
		break;
		}
	}
	UpdateData(FALSE);
	SaveDataToTestFile();
	return;
}

void CTaskGroupDlg::OnSelchangeTgTermination() 
{
	BOOL bEnableOptions = false;
	
	switch(m_ctlTGTermination.GetCurSel())
	{
	case 0:
		bEnableOptions = false;
		m_TGData.SetbIsDuration(TRUE);
		m_TGData.SetTaskDuration(-1);			
		m_ctlTimeLimit.ShowWindow(SW_HIDE);
		m_ctlIterations.ShowWindow(SW_HIDE);	
		m_ctlIterSpin.ShowWindow(SW_HIDE);
		m_strCaption = "";	//no caption
	break;
	case 1:
	{
		m_TGData.SetbIsDuration(TRUE);
		m_strCaption = "Time Limit";
		m_ctlTimeLimit.ShowWindow(SW_SHOW);
		m_ctlIterations.ShowWindow(SW_HIDE);
		m_ctlIterSpin.ShowWindow(SW_HIDE);
		bEnableOptions = true;
	
		long lDuration = m_TGData.GetTaskDuration();
		if(lDuration < 0)
		{
			lDuration =0;
			m_TGData.SetTaskDuration(lDuration);
		}

		CTimeSpan TS(lDuration);
		m_ctlTimeLimit.SetHours(TS.GetHours());
		m_ctlTimeLimit.SetMinutes(TS.GetMinutes());
		m_ctlTimeLimit.SetSeconds(TS.GetSeconds());
	}
	break;
	case 2:
	{
		m_TGData.SetbIsDuration(FALSE);
		m_strCaption = "Iterations";
		m_ctlTimeLimit.ShowWindow(SW_HIDE);
		m_ctlIterations.ShowWindow(SW_SHOW);
		m_ctlIterSpin.ShowWindow(SW_SHOW);
		m_nIterations = m_TGData.GetTaskIterations();
		bEnableOptions = true;
	}
	break;
	default:
	break;
	}

	m_ctlTimeLimit.EnableWindow(bEnableOptions);
	m_ctlIterations.EnableWindow(bEnableOptions);
	m_ctlIterSpin.EnableWindow(bEnableOptions);

	UpdateData(FALSE);
	SaveDataToTestFile();
}

void CTaskGroupDlg::SaveDataToTestFile()
{
	if(m_nTaskGroup == -1)
		return;

	//Delete the old script data from the testfile
	DWORD dwBufSize;
	LPBYTE pData;
	m_pTestFile->GetTaskGroupData(m_nTaskGroup,&pData,dwBufSize);
	delete []pData;

	//Get size of buffer required
	m_TGData.SaveToBuffer(NULL,dwBufSize);

	//create a buffer and save data to it
	pData = new BYTE[dwBufSize];
	m_TGData.SaveToBuffer(pData,dwBufSize);

	//set the data in the test file
	m_pTestFile->SetTaskGroupData(m_nTaskGroup,pData,dwBufSize);

	//Tell test ctrl data has changed
	::SendMessage(m_hwndNotify,WMU_REFRESH_LIST,0,MAKELPARAM(m_nTaskGroup+1,CTestCtrl::enScheduleCol));
}


void CTaskGroupDlg::OnChangeIterations() 
{
	if(m_nTaskGroup==-1)
		return;

	UpdateData();
	if(m_nIterations<1)
	{
		m_nIterations=1;
		m_TGData.SetTaskIterations(m_nIterations);
		SaveDataToTestFile();
		UpdateData(FALSE);
	}
	else
	{
		m_TGData.SetTaskIterations(m_nIterations);
		SaveDataToTestFile();
	}
}


void CTaskGroupDlg::OnChangeStartatDays() 
{
	if(m_nTaskGroup==-1)
		return;

	UpdateData();

	VerifyStartAtTime();

	int nSecs = m_ctlStartAtTime.GetSeconds();
	int nMins = m_ctlStartAtTime.GetMinutes();
	int nHours = m_ctlStartAtTime.GetHours();

	CString strTime;
	if(m_nStartAtDays>999)
	{
		m_nStartAtDays=999;
		strTime.Format("+%d %02d:%02d:%02d",m_nStartAtDays,nHours,nMins,nSecs);
	
		if(strTime != m_TGData.GetScheduledTime())
		{
			m_TGData.SetScheduledTime(strTime);
			SaveDataToTestFile();
		}
		UpdateData(FALSE);
	}
	else
	{
		strTime.Format("+%d %02d:%02d:%02d",m_nStartAtDays,nHours,nMins,nSecs);
	
		if(strTime != m_TGData.GetScheduledTime())
		{
			m_TGData.SetScheduledTime(strTime);
			SaveDataToTestFile();
		}
	}
}

void CTaskGroupDlg::VerifyStartAtTime()
{
	int nSecs = m_ctlStartAtTime.GetSeconds();
	int nMins = m_ctlStartAtTime.GetMinutes() + (nSecs/60);
	nSecs %= 60;
	int nHours = m_ctlStartAtTime.GetHours() + (nMins/60);
	nMins %= 60;
	m_nStartAtDays += (nHours/24);
	nHours %= 24;

	m_ctlStartAtTime.SetHours(nHours);
	m_ctlStartAtTime.SetMinutes(nMins);
	m_ctlStartAtTime.SetSeconds(nSecs);

	UpdateData(FALSE);
}

void CTaskGroupDlg::VerifyDelayTime()
{
	int nSecs = m_ctlStartDelay.GetSeconds();
	int nMins = m_ctlStartDelay.GetMinutes() + (nSecs/60);
	nSecs %= 60;
	int nHours = m_ctlStartDelay.GetHours() + (nMins/60);
	nMins %= 60;
	m_nDelayDays += (nHours/24);
	nHours %= 24;

	m_ctlStartDelay.SetHours(nHours);
	m_ctlStartDelay.SetMinutes(nMins);
	m_ctlStartDelay.SetSeconds(nSecs);

	UpdateData(FALSE);
}

void CTaskGroupDlg::OnChangeStartatTime() 
{
	if(m_nTaskGroup==-1)
		return;

	UpdateData();

//	VerifyStartAtTime();

	int nSecs = m_ctlStartAtTime.GetSeconds();
	if(nSecs>59)
	{
		nSecs=59;
		m_ctlStartAtTime.SetSeconds(nSecs);
	}
	int nMins = m_ctlStartAtTime.GetMinutes();
	if(nMins>59)
	{
		nMins=59;
		m_ctlStartAtTime.SetMinutes(nMins);
	}
	int nHours = m_ctlStartAtTime.GetHours();
	if(nHours>23)
	{
		nHours=23;
		m_ctlStartAtTime.SetHours(nHours);
	}

	CString strTime;
	strTime.Format("+%d %02d:%02d:%02d",m_nStartAtDays,nHours,nMins,nSecs);
	
	if(strTime != m_TGData.GetScheduledTime())
	{
		m_TGData.SetScheduledTime(strTime);
		SaveDataToTestFile();
	}
}

void CTaskGroupDlg::OnChangeTimelimit() 
{
	if(m_nTaskGroup==-1)
		return;

	int nHours = m_ctlTimeLimit.GetHours();
	int nMins = m_ctlTimeLimit.GetMinutes();
	int nSecs = m_ctlTimeLimit.GetSeconds();

	CTimeSpan TS(0,nHours,nMins,nSecs);
	long lDuration = TS.GetTotalSeconds();
	
	if(lDuration != m_TGData.GetTaskDuration())
	{
		m_TGData.SetTaskDuration(lDuration);
		SaveDataToTestFile();
	}
}

BOOL CTaskGroupDlg::SetWindowEnabled()
{	
	
	//get the cwnd of this dialog
	if(IsWindowEnabled()==FALSE)
	{
		m_ctlStartDelay.EnableWindow(FALSE);
		GetDlgItem(IDC_DELAY_BOX)->EnableWindow(TRUE);
		GetDlgItem(IDC_START_DELAY)->EnableWindow(FALSE);
		m_WarningString="";//These fields cannot be edited because the Task group is in use, if a test is running disable the Task group before attempting to edit it";
		GetDlgItem(IDC_TG_START)->EnableWindow(FALSE);
		GetDlgItem(IDC_STARTAT_DAYS)->EnableWindow(FALSE);
		GetDlgItem(IDC_STARTAT_DAYS_SPIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_ITERATIONS)->EnableWindow(FALSE);
		GetDlgItem(IDC_TG_TERMINATION)->EnableWindow(FALSE);
		GetDlgItem(IDC_ITER_SPIN)->EnableWindow(FALSE);
		m_ctlTimeLimit.EnableWindow(FALSE);
		m_ctlStartAtTime.EnableWindow(FALSE);

		GetDlgItem(IDC_DELAY_DAYS)->EnableWindow(FALSE);
		GetDlgItem(IDC_DELAY_DAYS_SPIN)->EnableWindow(FALSE);
	}
	else
	{
		m_ctlStartDelay.EnableWindow(TRUE);
		GetDlgItem(IDC_START_DELAY)->EnableWindow(TRUE);
		GetDlgItem(IDC_DELAY_BOX)->EnableWindow(TRUE);
		m_WarningString="";//These fields can be edited";
		GetDlgItem(IDC_TG_START)->EnableWindow(TRUE);
		GetDlgItem(IDC_STARTAT_DAYS)->EnableWindow(TRUE);
		GetDlgItem(IDC_STARTAT_DAYS_SPIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_ITERATIONS)->EnableWindow(TRUE);
		GetDlgItem(IDC_TG_TERMINATION)->EnableWindow(TRUE);
		GetDlgItem(IDC_ITER_SPIN)->EnableWindow(TRUE);
		m_ctlTimeLimit.EnableWindow(TRUE);
		m_ctlStartAtTime.EnableWindow(TRUE);

		GetDlgItem(IDC_DELAY_DAYS)->EnableWindow(TRUE);
		GetDlgItem(IDC_DELAY_DAYS_SPIN)->EnableWindow(TRUE);
	}
	UpdateData(FALSE);
	return true;
}



void CTaskGroupDlg::OnChangeStartDelay()
{
	
	if(m_nTaskGroup == -1)
		return;

	UpdateData();

	if(m_nDelayDays>999)
	{
		m_nDelayDays=999;
	}
	int nHours = m_ctlStartDelay.GetHours();
	if(nHours>23)
	{
		nHours=23;
		m_ctlStartDelay.SetHours(nHours);
	}
	int nMins = m_ctlStartDelay.GetMinutes();
	if(nMins>59)
	{
		nMins=59;
		m_ctlStartDelay.SetMinutes(nMins);
	}
	int nSecs = m_ctlStartDelay.GetSeconds();
	if(nSecs>59)
	{
		nSecs=59;
		m_ctlStartDelay.SetSeconds(nSecs);
	}

	CTimeSpan TS(m_nDelayDays,nHours,nMins,nSecs);
	long lDelay = TS.GetTotalSeconds();
	if(lDelay<1)
	{
		lDelay=1;
		m_ctlStartDelay.SetSeconds(lDelay);
	}
	UpdateData(FALSE);	//update to redraw if m,s>59 or h>23

	if(lDelay != m_TGData.GetStartDelay())
	{
		m_TGData.SetStartDelay(lDelay);
		SaveDataToTestFile();
	}

	return;
}

void CTaskGroupDlg::OnChangeDelayDays() 
{
	if(m_nTaskGroup==-1)
		return;

	UpdateData();
	VerifyDelayTime();	//calculate the days
	OnChangeStartDelay();

}

BOOL CTaskGroupDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	pHelpInfo->dwContextId = HIDD_TASKGROUP_DLG;
	return CDialog::OnHelpInfo(pHelpInfo);
}
