/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_)
#define AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitorSummary.h : header file
//
#include "TestFile.h"
#include "mthread.hpp"
#include <TestManager.h>
#include "resource.h"
#include "HeaderCtrlExt.h"

const int MAX_TASKS=200;

/////////////////////////////////////////////////////////////////////////////
// CMonitorSummary dialog
class CMonitorSummary : public CDialog
{

// Construction
public:
	void DisplaySimpleColumns();

	typedef enum{enTaskGroupCol,enStatusCol,enDurationCol,enHTTPrCol,enHTTPrperSecondCol,enHTTPeCol,enHTTPeperSecondCol,enHTTPbCol,enHTTPbperSecondCol,enBytesInCol,enBytesInperSecondCol,enBytesOutCol,enBytesOutperSecondCol,enMinCol,enAvgCol,enMaxCol,enTaskIterationsperSecondCol,enTotalVuCol,enActiveVuCol,enInactiveVuCol,enFirstTaskCol} ListMonitoringColumns;
	
	struct testSnap
	{
		long lTotalBytesIn;
		long lTotalBytesOut;
		long lMinRequestLatency;
		long lMaxRequestLatency;
		long lAvgRequestLatency;
		long lTotalFailedRequests;
		long lTotalRequests;
		long lTotalTaskIterations;
		long lMinConnectionTime;
		long lAvgConnectionTime;
		long lMaxConnectionTime;
		long lActiveVUs;
		long lInactiveVUs;
		int	nTaskGroups;
		int nExecuters;
	};

	struct taskStatus
	{
		long lTaskGroupId;
		BOOL bEnabled;
		TGExecStatus status;
	};

	BOOL Init(CString strManagerReg, CTestFile* pTestFile);
	CMonitorSummary(CWnd* pParent = NULL);   // standard constructor
	virtual ~CMonitorSummary();


	CArray<taskStatus,taskStatus> m_TaskStatus;

	TESnapList m_snapList1;
	HTTPTEsSnapshot m_HTTPTEsSnapList1;

	CString m_strManagerReg;
	CTestFile* m_pTestFile;
	HANDLE m_hCloseThread;

// Dialog Data
	//{{AFX_DATA(CMonitorSummary)
	enum { IDD = IDD_MON_SUMMARY };
	CStatic	m_ctlTestText;
	CStatic	m_ctlTGText;
	CListCtrl	m_ctlTestSummary;
	CListCtrl	m_ctlSummary;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitorSummary)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	int m_nInterval;//the refesh interval in milliseconds
	static UINT GetUpdate(LPVOID pParam);
	// Generated message map functions
	//{{AFX_MSG(CMonitorSummary)
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnShow0();
	afx_msg void OnShow1();
	afx_msg void OnShow2();
	afx_msg void OnShow3();
	afx_msg void OnShow4();
	afx_msg void OnShow5();
	afx_msg void OnShow6();
	afx_msg void OnShow7();
	afx_msg void OnShow8();
	afx_msg void OnShow9();
	afx_msg void OnShow10();
	afx_msg void OnShow11();
	afx_msg void OnShow12();
	afx_msg void OnShow13();
	afx_msg void OnShow14();
	afx_msg void OnMonShowActivevus();
	afx_msg void OnMonShowBytesinps();
	afx_msg void OnMonShowBytesoutps();
	afx_msg void OnMonShowHttpbps();
	afx_msg void OnMonShowHttpeps();
	afx_msg void OnMonShowHttprps();
	afx_msg void OnMonShowInactivevus();
	afx_msg void OnMonShowTasktotiterations();
	afx_msg void OnMonShowtestActivevus();
	afx_msg void OnMonShowtestAvgcon();
	afx_msg void OnMonShowtestAvglat();
	afx_msg void OnMonShowtestBytesinps();
	afx_msg void OnMonShowtestBytesoutps();
	afx_msg void OnMonShowtestHttpbps();
	afx_msg void OnMonShowtestHttpeps();
	afx_msg void OnMonShowtestHttprps();
	afx_msg void OnMonShowtestInactivevus();
	afx_msg void OnMonShowtestMaxcon();
	afx_msg void OnMonShowtestMaxlat();
	afx_msg void OnMonShowtestMincon();
	afx_msg void OnMonShowtestMinlat();
	afx_msg void OnMonShowtestTaskiterations();
	afx_msg void OnMonShowtestVus();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
			
private:
	BOOL HitTaskGroupSummary(CPoint point);
	BOOL HitTestSummary(CPoint point);

	testSnap m_TestWideStat1;
	testSnap m_TestWideStat2;

	double GetRate(int nCurrent,int nOld, int nSeconds);

	CString ConvertToSeconds(long milliseconds);
	CPoint m_ptContextClick;

	void ToggleColumn(int nCol, int nWidth);
	void ToggleTestColumn(int nCol, int nWidth);
	void SaveColumnState();

	CCriticalSection m_ArrayLocked;
	CString ConvertToTimeMilliseconds(long milliseconds);
	CString ConvertTimeToString(long duration);
	int m_nMaxUsedTaskCol;
	int m_nTaskGroups;
	CString LookupTargetType(CString strTarget);

	void UpdateSummary();
	int m_nTotalIndex;
    CWinThread* m_pUpdateThread;

	typedef struct {
		CString strName;
		CString strExtension;
	}PluginInfo;

	typedef	struct 
	{
		long lTaskGroupId;
		long lDuration;
		long lBytesIn;
		long lBytesOut;
		long lFailedRequests;
		long lRequests;
		long lSumTaskIterations;
		long lSumActiveUsers;
	}taskGroupData;

	CArray <taskGroupData,taskGroupData> m_DataTime1;
	CArray <taskGroupData,taskGroupData> m_DataTime2;


	CList <PluginInfo,PluginInfo&> m_listPlugins;
	int LoadProfileTypes();

	int m_nLatestSnapshot;

	CHeaderCtrlEx m_TestHeaderCtrl;
	CHeaderCtrlEx m_TGHeaderCtrl;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORSUMMARY_H__39FACE0F_018C_471A_BF5D_CE91AAB878BC__INCLUDED_)
