/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_MONITORINGDLG_H__81F44674_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_MONITORINGDLG_H__81F44674_D4E6_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MonitoringDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMonitoringDlg dialog
#include "TestFile.h"
#include "MonitorSummary.h"
#include "MonitoringErrorLog.h"
#include "MonitorVU.h"
#include "GraphWnd.h"
#include "MonitoringBar.h"
#include "resource.h"

class CMonitoringDlg : public CDialog
{
// Construction
public:
	void StopActiveTest();
	void SetTestActive(CString strReg);
	void SetTestFile(CTestFile* pTestFile);
	CMonitoringDlg(CWnd* pParent = NULL);   // standard constructor
	void SetMonitoringBar(CMonitoringBar *pBar);

// Dialog Data
	//{{AFX_DATA(CMonitoringDlg)
	enum { IDD = IDD_MONITORING };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMonitoringDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMonitoringDlg)
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTilehorizontally();
	afx_msg void OnTilevertically();
	afx_msg void OnCascade();
	afx_msg void OnToggleShowMonBar();
	afx_msg void OnUpdateToggleShowMonBar(CCmdUI* pCmdUI);
	afx_msg void OnCloseAll();
	afx_msg void OnTaskmonInterval();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnEndStepbystep();
	afx_msg void OnUpdateEndStepbystep(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg LRESULT OnMDIStateChanged(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnMonitorSelChanged(WPARAM,LPARAM);
	afx_msg BOOL OnEraseBkgnd(CDC *pDC);
	DECLARE_MESSAGE_MAP()
private:
	void ShowSummary(const CString& strTitle);
	void ShowErrorLog(const CString& strTitle);
	void ShowTotalActiveUsers(const CString& strTitle);
	void ShowStepByStepScreen();
	void ShowControlBars(BOOL bShow);

	CTestFile* m_pTestFile;
	CString m_strTestName;
	CString m_strManagerReg;
	BOOL m_bTestActive;
	BOOL FindTestRunFolder();

	CString m_strTestPath;
	CString m_strRunFolder;

	CMDIFrameWnd *m_pFrame;

	typedef struct 
	{
		CMonitoringBar::NM_MONITOR monInfo;
		CString strTitle;
		CGraphWnd *pChildWnd;
	}OpenWnd;

	CArray <OpenWnd,OpenWnd> m_arrOpenWnds;
	CGraphWnd *CreateNewChild(const CString& strTitle);

	CGraphWnd *m_pSBSWnd;
	CMonitoringBar *m_pMonitorBar;
	BOOL m_bMonBarVisible;
	BOOL m_bFirstSize;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MONITORINGDLG_H__81F44674_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
