/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include <afxtempl.h>
#ifndef __OSTA_GLOBAL_DEFS__
#define __OSTA_GLOBAL_DEFS__

const CString strScriptType ("Scripts");
const CString strTestType ("Tests");
const CString strProfileType ("Profiles");
const CString strProjectType ("Project");

const CString strClipboardFormat("OSTA Clipboard Format");

const CString strCaptureFolder ("Captures");
const CString strObjectCodeFolder ("ObjectCode");
const CString strArchMgrFolder ("ArchMgr");
const CString strIncludeFolder (strScriptType + "\\Include");
const CString strDataFolder ("Data");

const CString strSummaryFile ("Summary.txt");
const CString strResultsTestFile ("TestConf.dat");
const CString strTraceSettingsFile ("TraceSettings.txt");

typedef struct
{
	static int GetSize(){return sizeof(int);}	//sizeof of member vars not including data

	enum {enScript,enProfile,enTest,enTaskGroup} nDataType;

	LPBYTE GetData()
	{
		return (LPBYTE)(this) + sizeof(int);
	}
}ClipboardData;

struct GraphInfo
{
	CString strName;
	BOOL bFolder;
	CStringArray arstrMenuItems;
public:
	operator=(GraphInfo& GI)
	{
		strName = GI.strName;
		bFolder = GI.bFolder;
		arstrMenuItems.Copy(GI.arstrMenuItems);
	}
};

typedef CArray<GraphInfo,GraphInfo&> GraphInfoArray;

#define ID_CLOSEALL                     57000
#define ID_TILEVERTICALLY               57001
#define ID_TILEHORIZONTALLY             57002
#define ID_CASCADE                      57003

#endif __OSTA_GLOBAL_DEFS__
