/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// GatewayObject.h: interface for the CGatewayObject class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_GATEWAYOBJECT_H__1BB94253_F4F9_11D3_AC83_00105A483E3C__INCLUDED_)
#define AFX_GATEWAYOBJECT_H__1BB94253_F4F9_11D3_AC83_00105A483E3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <EnumData.h>
#include <httpCaptureCmd.hpp>
#include <BrowserInformation.h>
#include <exception.hpp>

#pragma warning( disable : 4786 )

class CModellerDoc ;

class CGatewayObject
{
    CModellerDoc*               m_pDoc ;
    _TPreferencesGatewayData    m_Data ;
    BOOL                        m_bPause ;
    CBrowserInformation*        m_pBrowserInfo ;

public:
    CGatewayObject(CModellerDoc *_pDoc );
    virtual ~CGatewayObject();

    BOOL GetDefaultParameters(  _TPreferencesProxyData *pData ) ;
    BOOL Record(BOOL _bConsole, BOOL _bTrace,BOOL _bAutoCookieGen);
    void PauseRecord();
    BOOL StopRecord() ;
    void InsertComments( const CString &strComments, unsigned long ulMillisecond ) ;
    void GetSCLRecordedScript( CString & strScript ) ;

protected:

    //Execute one statement
    void ExecuteCommand( const CString &strExe ) ;
    BOOL QuitCommand() ;

    //Run Gateway
    BOOL ConfigureGateway(BOOL _bConsole, BOOL _bTrace,BOOL _bAutoCookieGen) ;
    BOOL RunGateway() ;

    //Run Browser
    BOOL LaunchBrowser() ;

    //Launch error MessageBox
    void DisplayErrorCaptureMessage( long lID ) ;

    //Display gateway error Message
    void DisplayGatewayMessage( const CTException& e ) ;

	//Register/Unregister the capture browser helper object
	void LoadCaptureBHO(bool bLoad =true);
};

#endif // !defined(AFX_GATEWAYOBJECT_H__1BB94253_F4F9_11D3_AC83_00105A483E3C__INCLUDED_)
