/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// SCLGenerator.h: interface for the CSCLGenerator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCLGENERATOR_H__85D0FF67_2B16_11D4_BEBE_00A024AC5351__INCLUDED_)
#define AFX_SCLGENERATOR_H__85D0FF67_2B16_11D4_BEBE_00A024AC5351__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <VarStructures.h>

class CSCLGenerator
{
public:
    CSCLGenerator();
    virtual ~CSCLGenerator();

    static CString GenVarFileDecl( const CString& _strVarName,  const CString& _strFileName,
                                   int _nVarType, int _nVarScope ) ;
    static CString GenVarValListDecl( const CString& _strVarName, CStringArray * const _strVarValues,
                                      int _nVarOrder, int _nVarType, int _nVarScope,int _nSeed ) ;
    static CString GenVarSimpleDecl( const CString& _strVarName, int _nVarOrder,
                                     int _nVarType, int _nVarScope ) ;
    static CString GenVarResponseInfoDecl( const CString& _strVarName ) ;

    static CString GenVarResponseInfoStat( CVarResponse * _pVarResponse ) ;

    static CString GetVarScopeString( int _nVarScope ) ;
    static CString GetVarOrderString( int _nVarOrder,int nSeed=0 ) ;
    static CString GetVarTypeString( int _nVarType ) ;
    static CString GetVarValuesString( CStringArray * _astrVarValues, int _nVarType ) ;
    static CString GetDisplayString( CString _strSeparator, CString _strCode, long _nMaxLineSize,
                                     CString _strToInsert, CString _strDefaultInsert ) ;
};

#endif // !defined(AFX_SCLGENERATOR_H__85D0FF67_2B16_11D4_BEBE_00A024AC5351__INCLUDED_)
