/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// FilterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HttpStatsOcx.h"
#include "FilterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg dialog


CFilterDlg::CFilterDlg(FilterData* pFilterData,CWnd* pParent /*=NULL*/)
        : CDialog(CFilterDlg::IDD, pParent)
{
    m_pFilterData = pFilterData;
    //{{AFX_DATA_INIT(CFilterDlg)
    m_dwReplySizeEnd = 0;
    m_dwReplySizeStart = 0;
    m_dwRespTimeEnd = 0;
    m_dwRespTimeStart = 0;
    m_dwRespCodeEnd = 0;
    m_dwRespCodeStart = 0;
    m_strEndTime = _T("");
    m_strStartTime = _T("");
    //}}AFX_DATA_INIT

    int nNdx=0;
    CString str;
    bool bSelected;
    m_arstrUrls.SetSize(m_pFilterData->mapUrls.GetCount());
    POSITION pos = m_pFilterData->mapUrls.GetStartPosition();
    while(pos)
    {
        m_pFilterData->mapUrls.GetNextAssoc(pos,m_arstrUrls[nNdx++],bSelected);
    }

    nNdx = 0;
    m_arstrUserIds.SetSize(m_pFilterData->mapUserIds.GetCount());
    pos = m_pFilterData->mapUserIds.GetStartPosition();
    while(pos)
    {
        m_pFilterData->mapUserIds.GetNextAssoc(pos,m_arstrUserIds[nNdx++],bSelected);
    }
}


void CFilterDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CFilterDlg)
    DDX_Control(pDX, IDC_USER_ID_LIST, m_ctlUserIdList);
    DDX_Control(pDX, IDC_URL_LIST, m_ctlUrlList);
    DDX_Control(pDX, IDC_END_TIME, m_ctlEndTime);
    DDX_Control(pDX, IDC_START_TIME, m_ctlStartTime);
    DDX_Control(pDX, IDC_RESP_TIME_START_SPIN, m_ctlRespTimeStartSpin);
    DDX_Control(pDX, IDC_RESP_TIME_END_SPIN, m_ctlRespTimeEndSpin);
    DDX_Control(pDX, IDC_RESP_CODE_START_SPIN, m_ctlRespCodeStartSpin);
    DDX_Control(pDX, IDC_RESP_CODE_END_SPIN, m_ctlRespCodeEndSpin);
    DDX_Control(pDX, IDC_REPLY_SIZE_START_SPIN, m_ctlReplySizeStartSpin);
    DDX_Control(pDX, IDC_REPLY_SIZE_END_SPIN, m_ctlReplySizeEndSpin);
    DDX_Text(pDX, IDC_REPLY_SIZE_END, m_dwReplySizeEnd);
    DDX_Text(pDX, IDC_REPLY_SIZE_START, m_dwReplySizeStart);
    DDX_Text(pDX, IDC_RESP_TIME_END, m_dwRespTimeEnd);
    DDX_Text(pDX, IDC_RESP_TIME_START, m_dwRespTimeStart);
    DDX_Text(pDX, IDC_RESP_CODE_END, m_dwRespCodeEnd);
    DDX_Text(pDX, IDC_RESP_CODE_START, m_dwRespCodeStart);
    DDX_Text(pDX, IDC_END_TIME, m_strEndTime);
    DDX_Text(pDX, IDC_START_TIME, m_strStartTime);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CFilterDlg, CDialog)
//{{AFX_MSG_MAP(CFilterDlg)
ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
ON_NOTIFY(LVN_GETDISPINFO, IDC_USER_ID_LIST, OnGetdispinfoUserIdList)
ON_NOTIFY(LVN_GETDISPINFO, IDC_URL_LIST, OnGetdispinfoUrlList)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg message handlers

BOOL CFilterDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    COleDateTime dtEnd((time_t)m_pFilterData->dwTimeEnd);
    m_strEndTime = dtEnd.Format();

    COleDateTime dtStart((time_t)m_pFilterData->dwTimeStart);
    m_strStartTime = dtStart.Format();

    m_dwReplySizeEnd = m_pFilterData->dwReplySizeEnd;
    m_dwReplySizeStart = m_pFilterData->dwReplySizeStart;
    m_dwRespCodeEnd = m_pFilterData->wRespCodeEnd;
    m_dwRespCodeStart = m_pFilterData->wRespCodeStart;
    m_dwRespTimeEnd = m_pFilterData->dwRespTimeEnd;
    m_dwRespTimeStart = m_pFilterData->dwRespTimeStart;

    //Setup url list
    m_ctlUrlList.SetRedraw(FALSE);
    m_ctlUrlList.InsertColumn(0,"",LVCFMT_LEFT,1000);
    int nNumUrls = m_pFilterData->mapUrls.GetCount();
    m_ctlUrlList.SetItemCount(nNumUrls);

    int nURL=0;
    CString str;
    bool bSelected;
    POSITION pos = m_pFilterData->mapUrls.GetStartPosition();
    while(pos)
    {
        m_pFilterData->mapUrls.GetNextAssoc(pos,str,bSelected);

        m_ctlUrlList.InsertItem(nURL,LPSTR_TEXTCALLBACK);
        if(bSelected)
            m_ctlUrlList.SetItemState(nURL,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED);
        nURL++;
    }
    m_ctlUrlList.SetRedraw();

    //Setup user id list
    m_ctlUserIdList.SetRedraw(FALSE);
    m_ctlUserIdList.InsertColumn(0,"",LVCFMT_LEFT,1000);

    int nNumIDs = m_pFilterData->mapUserIds.GetCount();
    m_ctlUserIdList.SetItemCount(nNumIDs);

    int nID=0;
    pos = m_pFilterData->mapUserIds.GetStartPosition();
    while(pos)
    {
        m_pFilterData->mapUserIds.GetNextAssoc(pos,str,bSelected);

        m_ctlUserIdList.InsertItem(nID,LPSTR_TEXTCALLBACK);
        if(bSelected)
            m_ctlUserIdList.SetItemState(nID,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED);

        nID++;
    }
    m_ctlUserIdList.SetRedraw();

    const int nNumAccel = 3;
    UDACCEL arAccel[nNumAccel];
    arAccel[0].nInc = 1;
    arAccel[0].nSec = 2;
    arAccel[1].nInc = 10;
    arAccel[1].nSec = 3;
    arAccel[2].nInc = 100;
    arAccel[2].nSec = 4;

    m_ctlReplySizeEndSpin.SetRange32(0,0x7fffffff);
    m_ctlReplySizeEndSpin.SetPos(m_dwReplySizeEnd);
    m_ctlReplySizeEndSpin.SetAccel(nNumAccel,arAccel);

    m_ctlReplySizeStartSpin.SetRange32(0,0x7fffffff);
    m_ctlReplySizeStartSpin.SetPos(m_dwReplySizeStart);
    m_ctlReplySizeStartSpin.SetAccel(nNumAccel,arAccel);

    m_ctlRespCodeEndSpin.SetRange32(0,0xffff);
    m_ctlRespCodeEndSpin.SetPos(m_dwRespCodeEnd);
    m_ctlRespCodeEndSpin.SetAccel(nNumAccel,arAccel);

    m_ctlRespCodeStartSpin.SetRange32(0,0xffff);
    m_ctlRespCodeStartSpin.SetPos(m_dwRespCodeStart);
    m_ctlRespCodeStartSpin.SetAccel(nNumAccel,arAccel);

    m_ctlRespTimeEndSpin.SetRange32(0,0x7fffffff);
    m_ctlRespTimeEndSpin.SetPos(m_dwRespTimeEnd);
    m_ctlRespTimeEndSpin.SetAccel(nNumAccel,arAccel);

    m_ctlRespTimeStartSpin.SetRange32(0,0x7fffffff);
    m_ctlRespTimeStartSpin.SetPos(m_dwRespTimeStart);
    m_ctlRespTimeStartSpin.SetAccel(nNumAccel,arAccel);

    UpdateData(FALSE);
    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CFilterDlg::OnDefaults()
{
    COleDateTime dtEnd((time_t)m_pFilterData->dwDefTimeEnd);
    m_strEndTime = dtEnd.Format();

    COleDateTime dtStart((time_t)m_pFilterData->dwDefTimeStart);
    m_strStartTime = dtStart.Format();

    m_dwReplySizeEnd = m_pFilterData->dwDefReplySizeEnd;
    m_dwReplySizeStart = m_pFilterData->dwDefReplySizeStart;
    m_dwRespCodeEnd = m_pFilterData->wDefRespCodeEnd;
    m_dwRespCodeStart = m_pFilterData->wDefRespCodeStart;
    m_dwRespTimeEnd = m_pFilterData->dwDefRespTimeEnd;
    m_dwRespTimeStart = m_pFilterData->dwDefRespTimeStart;

    //Reset url list
    m_ctlUrlList.SetRedraw(FALSE);
    const int nNumUrls = m_ctlUrlList.GetItemCount();
    for(int nURL=0;nURL<nNumUrls;nURL++)
    {
        m_ctlUrlList.SetItemState(nURL,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED);
    }
    m_ctlUrlList.SetRedraw();

    //Reset user id list
    m_ctlUserIdList.SetRedraw(FALSE);

    const int nNumIDs = m_ctlUserIdList.GetItemCount();

    for(int nID=0;nID<nNumIDs;nID++)
    {
        m_ctlUserIdList.SetItemState(nID,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED);
    }
    m_ctlUserIdList.SetRedraw();

    m_ctlReplySizeEndSpin.SetPos(m_dwReplySizeEnd);
    m_ctlReplySizeStartSpin.SetPos(m_dwReplySizeStart);
    m_ctlRespCodeEndSpin.SetPos(m_dwRespCodeEnd);
    m_ctlRespCodeStartSpin.SetPos(m_dwRespCodeStart);
    m_ctlRespTimeEndSpin.SetPos(m_dwRespTimeEnd);
    m_ctlRespTimeStartSpin.SetPos(m_dwRespTimeStart);

    UpdateData(FALSE);
}

void CFilterDlg::OnOK()
{
    UpdateData(TRUE);

    //TODO: start/end times
    DWORD dwStartTime=0;
    DWORD dwEndTime=0;
    COleDateTime dt;

    if(!dt.ParseDateTime(m_strStartTime))
    {
        MessageBox("Please enter a valid start time for the filter","Filter",MB_ICONINFORMATION);
        return;
    }
    SYSTEMTIME ST;
    dt.GetAsSystemTime(ST);
    CTime tStart(ST);
    dwStartTime = tStart.GetTime();
	
    if(!dt.ParseDateTime(m_strEndTime))
    {
        MessageBox("Please enter a valid end time for the filter","Filter",MB_ICONINFORMATION);
        return;
    }
    dt.GetAsSystemTime(ST);
    CTime tEnd(ST);
    dwEndTime = tEnd.GetTime();

    m_pFilterData->dwTimeStart = dwStartTime;
    m_pFilterData->dwTimeEnd = dwEndTime;
    m_pFilterData->dwReplySizeEnd = m_dwReplySizeEnd;
    m_pFilterData->dwReplySizeStart = m_dwReplySizeStart;
    m_pFilterData->wRespCodeEnd = (WORD)m_dwRespCodeEnd;
    m_pFilterData->wRespCodeStart = (WORD)m_dwRespCodeStart;
    m_pFilterData->dwRespTimeEnd = m_dwRespTimeEnd;
    m_pFilterData->dwRespTimeStart = m_dwRespTimeStart;

    POSITION pos=NULL;
    bool bSelection=false;
    int nItem=0;

    //Set all entries in map to unselected...
    const int nNumUrls = m_arstrUrls.GetSize();
    for(int nNdx=0;nNdx<nNumUrls;nNdx++)
    {
        m_pFilterData->mapUrls.SetAt(m_arstrUrls[nNdx],bSelection);
    }

    const int nNumIds = m_arstrUserIds.GetSize();
    for(nNdx=0;nNdx<nNumIds;nNdx++)
    {
        m_pFilterData->mapUserIds.SetAt(m_arstrUserIds[nNdx],bSelection);
    }

    //then select any which are selected in the list
    bSelection = true;
    pos = m_ctlUrlList.GetFirstSelectedItemPosition();
    while(pos)
    {
        nItem = m_ctlUrlList.GetNextSelectedItem(pos);
        m_pFilterData->mapUrls.SetAt(m_arstrUrls[nItem],bSelection);
    }

    pos = m_ctlUserIdList.GetFirstSelectedItemPosition();
    while(pos)
    {
        nItem = m_ctlUserIdList.GetNextSelectedItem(pos);
        m_pFilterData->mapUserIds.SetAt(m_arstrUserIds[nItem],bSelection);
    }

    CDialog::OnOK();
}

void CFilterDlg::OnGetdispinfoUserIdList(NMHDR* pNMHDR, LRESULT* pResult)
{
    LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

    LV_ITEM &lv = pDispInfo->item;
    if(lv.mask | LVIF_TEXT )
    {
        lv.pszText = m_arstrUserIds[lv.iItem].GetBuffer(0);
    }

    *pResult = 0;
}

void CFilterDlg::OnGetdispinfoUrlList(NMHDR* pNMHDR, LRESULT* pResult)
{
    LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

    LV_ITEM &lv = pDispInfo->item;
    if(lv.mask | LVIF_TEXT )
    {
        lv.pszText = m_arstrUrls[lv.iItem].GetBuffer(0);
    }

    *pResult = 0;
}
