/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// NTPerfPluginView.h : interface of the CNTPerfPluginView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NTPERFPLUGINVIEW_H__EF0C464A_0937_4AAD_A5D8_08FB7DD58BDF__INCLUDED_)
#define AFX_NTPERFPLUGINVIEW_H__EF0C464A_0937_4AAD_A5D8_08FB7DD58BDF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CECGridCtrl.h"

class CNTPerfPluginCntrItem;

class CNTPerfPluginView : public CFormView
{
protected: // create from serialization only
	CNTPerfPluginView();
	DECLARE_DYNCREATE(CNTPerfPluginView)

public:
	//{{AFX_DATA(CNTPerfPluginView)
	enum { IDD = IDD_PROFILE_EDIT };
	CButton	m_ctlGroup;
	//}}AFX_DATA

// Attributes
public:
	CNTPerfPluginDoc* GetDocument();
	// m_pSelection holds the selection to the current CNTPerfPluginCntrItem.
	// For many applications, such a member variable isn't adequate to
	//  represent a selection, such as a multiple selection or a selection
	//  of objects that are not CNTPerfPluginCntrItem objects.  This selection
	//  mechanism is provided just to help you get started.

	// TODO: replace this selection mechanism with one appropriate to your app.
	CNTPerfPluginCntrItem* m_pSelection;
	BOOL ReadProfile(CString strFilePath);
	BOOL WriteProfile(CString strFilePath);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNTPerfPluginView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL IsSelected(const CObject* pDocItem) const;// Container support
	//}}AFX_VIRTUAL
    afx_msg void OnDblClkQueryList(NMHDR* pNMHDR,LRESULT *pResult);

// Implementation
public:
	void SaveCurrentProfile();
	virtual ~CNTPerfPluginView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CNTPerfPluginView)
	afx_msg void OnDestroy();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInsertObject();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnAddRow();
	afx_msg void OnRemoveRow();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    CECGridCtrl m_wndGrid;
	void EditQuery(int nRow);
	enum { enDesc = 0, enQuery, enInterval, enDelta};
	BOOL m_bLoaded;
	int GetNextField(CString sep, CString &inStr, CString &field);

};

#ifndef _DEBUG  // debug version in NTPerfPluginView.cpp
inline CNTPerfPluginDoc* CNTPerfPluginView::GetDocument()
   { return (CNTPerfPluginDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NTPERFPLUGINVIEW_H__EF0C464A_0937_4AAD_A5D8_08FB7DD58BDF__INCLUDED_)
