/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// NTPerfGraphs.h: interface for the CNTPerfGraphs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NTPERFGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_NTPERFGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CGraphWnd;

typedef struct
{
	DWORD dwIP;
	int nIndex;
	DWORD dwStartTime;
	DWORD dwEndTime;
	double dValue;
}NTPStat;

typedef CList <NTPStat,NTPStat&> NTPStatList;

struct NTPHeader
{
	bool bInFilter;
	DWORD dwIP;
	int nIndex;
	CString strQuery;

	NTPHeader()
	{
		bInFilter = true;
	}

	NTPStatList listStats;
};

typedef CList <NTPHeader*,NTPHeader*> NTPHeaderList;

#include "ostadefs.h"

class CNTPerfGraphs  
{
public:
	CNTPerfGraphs();
	virtual ~CNTPerfGraphs();

	void LoadRun(const CString& strRunFolder);
	CWnd *DisplayGraph(const CString& strName,CWnd *pParent,const CRect& rcBounds);
	void GetAvailableGraphs(GraphInfoArray& arGraphs);

private:
	BOOL LoadGraph	(const CString& strName,CGraphWnd *pGraph);
	void LoadStats();

private:
	CString m_strLoadedRun;
	DWORD m_dwTestStartTime;

	NTPHeaderList m_listNTPData;

	const CString m_strCustomNTP;
};

#endif // !defined(AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
