/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_QUERYEDITDLG_H__735C996B_62FD_4E00_A7BE_69478239B0FD__INCLUDED_)
#define AFX_QUERYEDITDLG_H__735C996B_62FD_4E00_A7BE_69478239B0FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// QueryEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CQueryEditDlg dialog
#include "resource.h"
#include <afxtempl.h>
typedef struct
{
	CString strCatName;
	CString strWalkStart;
} CATEGORY;

class CQueryEditDlg : public CDialog
{
// Construction
public:
	CQueryEditDlg(CString strServer, CString strQuery, int nPort, CWnd* pParent = NULL);   // standard constructor
	CString GetQuery();
	CArray <CATEGORY,CATEGORY> m_arrCat;

// Dialog Data
	//{{AFX_DATA(CQueryEditDlg)
	enum { IDD = IDD_QUERY_EDIT };
	CListCtrl	m_ctlWalkList;
	CComboBox	m_ctlCategory;
	CString	m_strWalkPoint;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQueryEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CQueryEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCategory();
	virtual void OnOK();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void ReadCategories();
	CString m_szQuery;
	CString m_szServer;
	int m_nPort;
	void CQueryEditDlg::WalkTable(int nTable);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QUERYEDITDLG_H__735C996B_62FD_4E00_A7BE_69478239B0FD__INCLUDED_)
