/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// SNMPPluginDoc.cpp : implementation of the CSNMPPluginDoc class
//

#include "stdafx.h"
#include "SNMPPlugin.h"

#include "SNMPPluginDoc.h"
#include "SNMPPluginView.h"
#include "SrvrItem.h"
#include "OstaDefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc

IMPLEMENT_DYNCREATE(CSNMPPluginDoc, COleServerDoc)

BEGIN_MESSAGE_MAP(CSNMPPluginDoc, COleServerDoc)
	//{{AFX_MSG_MAP(CSNMPPluginDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc construction/destruction

CSNMPPluginDoc::CSNMPPluginDoc()
{
	OpenClipboard(NULL);
	HANDLE hData = GetClipboardData(RegisterClipboardFormat(strClipboardFormat));
	m_strProfilePath = (char *)GlobalLock(hData);
	GlobalUnlock(hData);
	CloseClipboard();
}

CSNMPPluginDoc::~CSNMPPluginDoc()
{
}

BOOL CSNMPPluginDoc::OnNewDocument()
{
	if (!COleServerDoc::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc server implementation

COleServerItem* CSNMPPluginDoc::OnGetEmbeddedItem()
{
	// OnGetEmbeddedItem is called by the framework to get the COleServerItem
	//  that is associated with the document.  It is only called when necessary.

	CSNMPPluginSrvrItem* pItem = new CSNMPPluginSrvrItem(this);
	ASSERT_VALID(pItem);
	return pItem;
}


/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc Active Document server implementation

CDocObjectServer *CSNMPPluginDoc::GetDocObjectServer(LPOLEDOCUMENTSITE pDocSite)
{
	return new CDocObjectServer(this, pDocSite);
}


/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc serialization

void CSNMPPluginDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc diagnostics

#ifdef _DEBUG
void CSNMPPluginDoc::AssertValid() const
{
	COleServerDoc::AssertValid();
}

void CSNMPPluginDoc::Dump(CDumpContext& dc) const
{
	COleServerDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSNMPPluginDoc commands
BOOL CSNMPPluginDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	POSITION pos = GetFirstViewPosition();
	CSNMPPluginView* pView = (CSNMPPluginView*)GetNextView(pos);
	ASSERT(pView);

	pView->WriteProfile(m_strProfilePath);
	
	return COleServerDoc::OnSaveDocument(lpszPathName);
}

CString CSNMPPluginDoc::GetProfilePath()
{
	return m_strProfilePath;
}
