/* Copyright (C) 2000-2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_GRAPHWND_H__E10D8B21_E7BD_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_GRAPHWND_H__E10D8B21_E7BD_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GraphWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGraphWnd window
class CXChartCtrl;
class CGraphTypeBase;
class CCustomizeGraphPage;
class CCustomizeTitlePage;
class CGraphWnd : public CWnd
{
	DECLARE_DYNAMIC(CGraphWnd);

	friend CCustomizeGraphPage;
	friend CCustomizeTitlePage;
// Construction
public:
	CGraphWnd();

// Attributes
public:

// Operations
public:
	CXChartCtrl *m_pChart;
	CGraphTypeBase *m_pGraph;
		
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGraphWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGraphWnd();
	void SetGraphStyles();

	// Generated message map functions
protected:
	//{{AFX_MSG(CGraphWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnExport();
	afx_msg void OnGraphCustomize();
	afx_msg void OnGraphMenuCommand(UINT nID);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void LoadGraphStyles();
	void SaveGraphStyles();


	//Properties
	BOOL m_bShowTitle;
	CString m_strTitle;
	CString m_strTitleFont;
	COLORREF m_colTitleText;
	COLORREF m_colTitleBk;
    COLORREF m_colPlotBk;
    CString m_strLabelFont;
    COLORREF m_colGrid;
    COLORREF m_colLabel;
    COLORREF m_colAxisText;
	CDWordArray m_arDefLineColours;
	
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAPHWND_H__E10D8B21_E7BD_11D4_94C9_00C04F89E392__INCLUDED_)
